///    FOUND HERE  https://www.youtube.com/watch?v=YUtqLjs-alo
// Thanks John Rogers !

#include "Arduino.h"
#include <ArduinoJson.h>
#include <ESP8266WiFi.h> //ESP8266 Core WiFi Library (you most likely already have this in your sketch)
//#include <WiFi.h>

#include <SoftwareSerial.h>
//SoftwareSerial swSer(14, 12, false, 256);
SoftwareSerial swSer(16, 2); //  RX  TX (D4)  , false, 256);
#include <DFPlayer_Mini_Mp3.h>
WiFiClient client;
int i;
int day, month, year, dayOfWeek;
int summerTime = 0;
String date;
byte flag1 = 0; // quater hour
byte flag2 = 0; // half hour
byte flag3 = 0; // three quarter hour
byte flag4 = 0; // hour
#define NUM_MAX 4
//// pins: D0-16,D1-5,D2-4,D3-0,D4-2,D5-14,D6-12,D7-13,D8-15,RX-3,TX-1 ////
// for NodeMCU 1.0
#define DIN_PIN 13  // D7
#define CS_PIN  0  // D3
#define CLK_PIN 14  // D5
#define buusyPin 4  //d2
#define SerOut 16 //d0
int bsy = 0;
int z = 0;
long epoch = 0;
unsigned long GetTimetime = millis();
unsigned long OneSecondSendtime = millis();
//#include "max7219.h"
//#include "fonts.h"
#define HOSTNAME "ESP8266-OTA-"
int val = 0;       // variable to store the value coming from the sensor
// =======================================================================
// CHANGE YOUR CONFIG HERE:
// =======================================================================
const char* ssid     = "main2";     // SSID of local network
const char* password = "Chumley8";   // Password on network
#define CO2_TX D4 //changed from D1 as it crashed with D1
#define CO2_RX D6  // note D6 is not used, just a place holder


// =============================DEFINE VARS==============================
#define MAX_DIGITS 4  // was 20
byte dig[MAX_DIGITS] = {0};
byte digold[MAX_DIGITS] = {0};
byte digtrans[MAX_DIGITS] = {0};
int updCnt = 0;
int dots = 0;
long dotTime = 0;
long clkTime = 0;
int dx = 0;
int dy = 0;
byte del = 0;
int h, m, s;
float utcOffset = -5; // -4=EDT,  -5=EST
long localEpoc = 0;
long localMillisAtUpdate = 0;



void setup()
{
  Serial.begin(9600);
  swSer.begin(9600);
  mp3_set_serial (Serial);  //set Serial for DFPlayer-mini mp3 module
  mp3_reset();
  delay (400);
  delay (400);
  Serial.print("Connecting WiFi ");
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("MyIP: "); Serial.println(WiFi.localIP());
  delay(1500);
  mp3_play(5); // for testing
  dlayPrint();
  GetTimetime = millis();
  OneSecondSendtime = millis();
  getTime();
  updateTime();
}
// =======================================================================
void loop() {
  if (updCnt <= 0) { // every 10 scrolls, ~450s=7.5m
    updCnt = 60;
    Serial.println("Getting data ...");
    getTime();
    Serial.println("Data loaded");
    clkTime = millis();
  }
  if (millis() - clkTime >= 60000 && !del && dots) { // clock for 30s, then scrolls for about 30s
    updCnt--;
    clkTime = millis();
  }
  if (millis() - dotTime >= 500) {
    dotTime = millis();
    dots = !dots;
  }

  if (millis() - GetTimetime >= 60000) {
    updateTime();
    GetTimetime = millis();
  }

  if (millis() - OneSecondSendtime >= 1000) {
    updateTime();
    //    Serial.print("T");
    //    Serial.println(epoch);
    //    swSer.println("T");
    //    swSer.println(epoch);
    OneSecondSendtime = millis();
  }

  if (m == 15 & flag1 == 0) {
    Serial.print("h= ");
    Serial.print(h);
    Serial.println(" found 15");
    mp3_play(1);
    Serial.println("play 1");
    dlayPrint();
    flag1 = 1;
    flag2 = 0;
    flag3 = 0;
    flag4 = 0;
  }
  if (m == 30 & flag2 == 0) {
    Serial.print("h= ");
    Serial.print(h);
    Serial.println(" found 30");
    mp3_play(2);
    Serial.println("play 2");
    dlayPrint();
    flag1 = 0;
    flag2 = 1;
    flag3 = 0;
    flag4 = 0;
  }
  if (m == 45 & flag3 == 0) {
    Serial.print("h= ");
    Serial.print(h);
    Serial.println(" found 45");
    mp3_play(3);
    Serial.println("play 3");
    dlayPrint();
    flag1 = 0;
    flag2 = 0;
    flag3 = 1;
    flag4 = 0;
  }
  if (m == 0 & flag4 == 0) {
    Serial.print("h= ");
    Serial.print(h);
    Serial.println(" found 00");
    mp3_play(4);
    Serial.println("play 4");
    dlayPrint();
    flag1 = 0;
    flag2 = 0;
    flag3 = 0;
    flag4 = 1;
    if (h >= 2) {
      if (h >= 13) {
        h = h - 12;
      }
      if (h == 0) {
        h = 12; // at midnight do 12 chimes
      }
      for (i = 1; i <= h - 1; i++) {
        mp3_play(5); // 5 is chime without end tail
        Serial.println("play 5");
        dlayPrint();
      }
    }
    mp3_play(6); // 6 is chime with long tail sound
    Serial.println("play 6");
  }
}

// routine to stay here till busy pin goes low once then goes high after speech item completes
void dlayPrint()
{
  int bsyflag = 0;
  ////  Serial.println(" ");
  ///// Serial.print("busypin ");
  for ( z = 0; z <= 1000; z++) {
    if (millis() - dotTime > 500) {
      dotTime = millis();
      dots = !dots;
    }
    bsy = digitalRead(buusyPin);
    /////  Serial.print(bsy);
    delay(20);
    if (bsyflag == 1 && bsy == 1) {
      break;
    }
    if (bsy == 0) {
      bsyflag = 1;
    }
  }
  ///// Serial.println(" ");
  ///// Serial.println("done");
}


// =======================================================================

void getTime()
{
  WiFiClient client;
  if (!client.connect("www.google.com", 80)) {
    Serial.println("connection to google failed");
    return;
  }

  client.print(String("GET / HTTP/1.1\r\n") +
               String("Host: www.google.com\r\n") +
               String("Connection: close\r\n\r\n"));
  int repeatCounter = 0;
  while (!client.available() && repeatCounter < 10) {
    delay(500);
    //Serial.println(".");
    repeatCounter++;
  }

  String line;
  client.setNoDelay(false);
  while (client.connected() && client.available()) {
    line = client.readStringUntil('\n');
    line.toUpperCase();
    if (line.startsWith("DATE: ")) {
      date = "     " + line.substring(6, 22);
      date.toUpperCase();
      //      decodeDate(date);
      h = line.substring(23, 25).toInt();
      m = line.substring(26, 28).toInt();
      s = line.substring(29, 31).toInt();
      summerTime = checkSummerTime();
      if (h + utcOffset + summerTime > 23) {
        if (++day > 31) {
          day = 1;
          month++;
        };  // needs better patch
        if (++dayOfWeek > 7) dayOfWeek = 1;
      }
      localMillisAtUpdate = millis();
      localEpoc = (h * 60 * 60 + m * 60 + s);
    }
  }
  client.stop();
  Serial.print("h@getTime= ");
  Serial.println(h);
}

// =======================================================================

int checkSummerTime()
{
  if (month > 3 && month < 10) return 1;
  if (month == 3 && day >= 31 - (((5 * year / 4) + 4) % 7) ) return 1;
  if (month == 10 && day < 31 - (((5 * year / 4) + 1) % 7) ) return 1;
  return 0;
}
// =======================================================================

void updateTime()
{
  long curEpoch = localEpoc + ((millis() - localMillisAtUpdate) / 1000);
  epoch = round(curEpoch + 3600 * ( summerTime) + 86400L) % 86400L;
  h = ((epoch  % 86400L) / 3600) % 24;
  m = (epoch % 3600) / 60;
  s = epoch % 60;
  //  epoch=epoch - 5 * 60*60;  // move ahead 5 hours for est
  //  Serial.print("T");
  //  Serial.println(epoch);
  swSer.println("T");
  swSer.println(epoch);
  // epoch=epoch + 5 * 60*60;  // move ahead 5 hours for est
  epoch = round(curEpoch + 3600 * (utcOffset + summerTime) + 86400L) % 86400L;
  //   Serial.print("h@updateTime= ");
  //// Hour (h) is in UTC- change to EST & 12 hour
  h = h - 5; // change to EST
  if (h <= 0) {   // if negative or zero add 12
    h = h + 12;
  }
  if (h > 12) {  // if over 12 change to 12 hour format
    h = h - 12;
  }
 // Serial.print("Fixed Hour = "); Serial.println(h);
}

// =======================================================================

